//Konfigurace
//Pocty a velikosti karticek
var countX = 4;
var countY = 4;
var imgWidth = 150;
var imgHeight = 150;

//Adresar s obrazky
var imgDirPrefix = "data/img/";

//Provozni globalni promenne
var gameStart = 0;
var success = 0;
var gameField = new Array();
var empty;
var timer;
var imgDir;

//Funkce volana po kliknuti na herni pole
function action(field)
{
	if(success != 0)
	{
		//Hra jiz skoncila
		return;
	}

	//Ulozi cas zahajeni hry
	if(gameStart == 0)
	{
		gameStart = new Date();
		timer = window.setInterval("viewTime()", 1000);
	}

	if(field != empty-countX && field != empty+countX && !(field == empty-1 && empty%countX != 0) && !(field == empty+1 && empty%countX != countX-1))
	{
		//Nepovolene presunuti
		return;
	}
	
	//Vymena obrazku
	var tmp = gameField[field]; 
	gameField[field] = gameField[empty];
	gameField[empty] = tmp;
	
	//Aktualizace obrazku
	document.getElementById("field_"+field).src = imgDir+"/empty.jpg";
	document.getElementById("field_"+empty).src = imgDir+"/"+gameField[empty]+".jpg";
	
	//Aktualizace prazdneho mista
	empty = field;
	
	//Ukonceni hry
	for(var i = 0; i < countX*countY; i++)
	{
		if(gameField[i] != i) return;
	}
	gameOver();
}

//Ukonceni hry a zobrazeni vyherni zpravy
function gameOver()
{
	success = 1;
	clearTimeout(timer);
	document.getElementById("field_0").src = imgDir+"/0.jpg";
	alert("Konec hry! Blahopřejeme k poskládání obrázku!");
}

//Casomira
function viewTime()
{
	var time = new Date();
	time.setTime(time.getTime()-gameStart.getTime());
	var seconds = time.getSeconds();
	if(seconds < 10) seconds = "0"+seconds; 
	document.getElementById("timer").innerHTML=time.getMinutes()+":"+seconds;
}

//Vykresleni herni plochy
function renderGameField(game)
{	
	initGameField(game);

	//Zobrazi tabulku s hernimi policky
	document.write("<table id=\"field\">");
	for(var y = 0; y < countY; y++)
	{
		document.write("<tr>");
		for(var x = 0; x < countX; x++)
		{
			var posId = y*countX+x;
			
			if(posId != empty) imgName = imgDir+"/"+gameField[posId]+".jpg";
			else imgName = imgDir+"/empty.jpg";
			
			document.write("<td onclick=\"action("+posId+")\">");
			document.write("<img src=\""+imgName+"\" id=\"field_"+posId+"\" width=\""+imgWidth+"\" height=\""+imgHeight+"\" alt=\"\"  />");
			document.write("</td>");
		}
		document.write("</tr>");
	}
	document.write("</table>");
}

function randomTurn()
{
	var oldEmpty = empty;
	switch(Math.round(Math.random()*3))
	{
		//Tah nahoru
		case 0:
			if(empty >= countX) empty -= countX;
			break;
		//Tah dolu
		case 1:
			if(empty < countX*(countY-1)) empty += countX;
			break;
		//Tah doleva
		case 2:
			if(empty%countX != 0) empty --;
			break;
		//Tah doprava
		case 3:
			if(empty%countX != countX-1) empty ++;
			break;
	}
	
	var tmp = gameField[empty];
	gameField[empty] = gameField[oldEmpty];
	gameField[oldEmpty] = tmp;
}

//Inicializace herniho pole
function initGameField(game)
{
	imgDir = imgDirPrefix+game;

	for(var i = 0; i < countX*countY; i++)
	{
		gameField[i] = i;
	}
		
	empty = 0;
	
	for(var i = 0; i < 1000; i++)
	{
		randomTurn();
	}
}

//Vykresleni nahledu
function renderPreview(game)
{
	document.write("<img src=\""+imgDirPrefix+game+"\/preview.jpg\" width=\"150\" height=\"150\" alt=\"\" id=\"preview\" />");
}
