//Konfigurace
//Pocty a velikosti karticek
var countX = 8;
var countY = 8;
var imgWidth = 80;
var imgHeight = 80;

//Velikost zoomu
var zoomX = 120;
var zoomY = 120;

//Adresar s obrazky karticek
var imgDir = "img/games/staryzakon";

//Cas zobrazeni karticek pri uspechu/neuspechu
var successTime = 1500;
var failedTime = 3000;

//Standardni pocet hracu, muze byt prepsano funkci renderPlayers
var players = 4;
var score = new Array(0,0,0,0,0);

//Provozni globalni promenne
var gameStart = 0;
var activePlayer = 1;
var uncovered = new Array();
var gameField = new Array();
var selected = -1;
var zoomHelper = -1; //Pomocna promenna pro potreby zoomu
var wait = false;
var used = 0;
var timer;
var zoomed = -1; //Pouziva se pri nespravnem uhadnuti karticky a zoomu

//Funkce volana po kliknuti na herni pole
function action(field)
{
	//Ulozi cas zahajeni hry
	if(gameStart == 0)
	{
		gameStart = new Date();
		timer = window.setInterval("viewTime()", 1000);
	}
	
	//Cekani na probehnuti animace nebo kliknuti na odkryte policko
	if(wait == true || uncovered[field] == true || selected == field) return true;
	
	//Odkryti oznacene karticky
	changeImage(field, gameField[field]+".jpg");
	
	//Oznaceni prvni karticky
	if(selected == -1)
	{
		selected = field;
	}
	//Oznaceni druhe karticky
	else
	{
		zoomHelper = field;
		//Byla oznacena dvojice
		if(gameField[field] == gameField[selected])
		{
			wait = true;
			setTimeout("turnSuccess("+field+", "+selected+")", successTime);
		}
		//Byla oznacena druha odlisna karticka
		else
		{
			wait = true;
			setTimeout("turnFailed("+field+", "+selected+")", failedTime);
		}
	}
	
	//Zoom na karticku
	zoomIn(field);
}

//Ukonceni hry a zobrazeni vyherni zpravy
function gameOver()
{
	unsetPlayer(activePlayer);
	clearTimeout(timer);
	document.getElementById("field").style.display="none";
	document.getElementById("winner").style.display="block";
	document.getElementById("winner").innerHTML="<h1>Konec hry! Blahopřejeme vítězi!</h1>";
}

//Uspesne odkryti dvojice karticek
function turnSuccess(first, second)
{
	changeImage(first, "uncovered.png");
	changeImage(second, "uncovered.png");

	uncovered[first] = true;
	uncovered[second] = true;
	selected = -1;
	zoomHelper = -1;
	addScore(activePlayer);
	wait = false;
	used++;

	//Zjisteni zda nastal konec hry
	if(used == (countX*countY)/2) gameOver();
	zoomOut();
}

//Odkryti ruznych karticek
function turnFailed(first, second)
{
	changeImage(first, "hidden.png");
	changeImage(second, "hidden.png");

	selected = -1;
	zoomHelper = -1;
	nextPlayer();
	wait = false;
	zoomHide();
}

//Zmena obrazku karticky
function changeImage(field, img)
{
	document.getElementById("field_"+field).src=imgDir+"/"+img;
}

//Casomira
function viewTime()
{
	var time = new Date();
	time.setTime(time.getTime()-gameStart.getTime());
	var seconds = time.getSeconds();
	if(seconds < 10) seconds = "0"+seconds; 
	document.getElementById("timer").innerHTML=time.getMinutes()+":"+seconds;
}

//Pricteni skore hraci
function addScore(player)
{
	score[player]++;
	document.getElementById("player_score_"+player).innerHTML=score[player];
}

//Zvyrazni aktualniho hrace
function setPlayer(player)
{
	var newPlayer = document.getElementById("player_"+player);
	newPlayer.style.backgroundColor="white";
	newPlayer.style.color="black";
}

//Zrusi zvyrazneni aktualniho hrace
function unsetPlayer(player)
{
	var oldPlayer = document.getElementById("player_"+player);
	oldPlayer.style.backgroundColor="black";
	oldPlayer.style.color="white";
}

//Prepnuti na dalsiho hrace
function nextPlayer()
{
	unsetPlayer(activePlayer);

	activePlayer++;
	if(activePlayer > players) activePlayer = 1;
	
	setPlayer(activePlayer);
}

//Vykresleni tabulky hracu a prepsani poctu hracu
function renderPlayers()
{
	//Pripadna zmena poctu hracu z parametru
	var tmp = window.location.search.substr(1);
	if(tmp >= 1 && tmp <= 6) players = tmp;
	
	//Inicializace pole se skore
	for(var i = 1; i <=players; i++) score[i] = 0;
	
	//Vykresleni tabulky hracu
	for(var id = 1; id <= players; id++)
	{
		document.write("<div class=\"player\" id=\"player_"+id+"\">");
		document.write("Hráč "+id);
		document.write("<div class=\"player_score\" id=\"player_score_"+id+"\">0</div>");
		document.write("</div>");
	}
}

//Zobrazi policko zoomu na spravnem miste a se spravnym obrazkem
function zoomIn(field)
{
	//Odkryte policka nezoomujeme
	if(uncovered[field] == true) return;
	
	//Uchovani nazoomovaneho policka po potreby zmeny obrazku
	zoomed = field;
	
	var zoom = document.getElementById("zoom");
	
	zoom.style.display="block";
	zoom.style.top=-(zoomY-imgHeight)/2+(imgHeight+1)*parseInt((field/countX))+"px";
	zoom.style.left=-(zoomX-imgWidth)/2+(imgWidth+1)*parseInt((field%countX))+"px";
	
	if(selected == field || zoomHelper == field) zoom.src=imgDir+"/zoom/"+gameField[field]+".jpg";
	else zoom.src=imgDir+"/zoom/hidden.png";
}

//Skryje nazoomovanou karticku
function zoomHide()
{
	if(zoomed != -1) document.getElementById("zoom").src=imgDir+"/zoom/hidden.png";
}

//Zneviditelni policko zoomu
function zoomOut()
{
	zoomed = -1;
	document.getElementById("zoom").style.display="none";
}

//Vykresli policko pro zobrazeni zoomu a obsluznou tabulku pro uzivatelsky vstup
function renderZoom()
{
	document.write("<img src=\""+imgDir+"/"+"1.jpg\" id=\"zoom\" width=\""+zoomX+"\" height=\""+zoomY+"\" alt=\"\" />");
	
	//Zobrazi pomocnou tabulku pro zoom
	document.write("<table id=\"zoom_table\">");
	for(var y = 0; y < countY; y++)
	{
		document.write("<tr>");
		for(var x = 0; x < countX; x++)
		{
			var posId = y*countX+x;
			document.write("<td style=\"width: "+imgWidth+"px; height: "+imgHeight+"px;\" onclick=\"action("+posId+")\" onmouseover=\"zoomIn("+posId+")\" onmouseout=\"zoomOut()\">");
			document.write("</td>");
		}
		document.write("</tr>");
	}
	document.write("</table>");
}

//Vykresleni herni plochy
function renderGameField()
{
	//Zobrazi tabulku s hernimi policky
	document.write("<table id=\"field\">");
	for(var y = 0; y < countY; y++)
	{
		document.write("<tr>");
		for(var x = 0; x < countX; x++)
		{
			var posId = y*countX+x;
			document.write("<td>");
			document.write("<a onclick=\"action("+posId+")\">");
			document.write("<img src=\""+imgDir+"/hidden.png\" id=\"field_"+posId+"\" width=\""+imgWidth+"\" height=\""+imgHeight+"\" alt=\"\"  />");
			document.write("</a>");
			document.write("</td>");
		}
		document.write("</tr>");
	}
	document.write("</table>");
}

//Inicializace herniho pole
function initGameField()
{
	for(var i = 0; i < countX*countY; i+=2)
	{
		gameField[i] = i/2+1;
		gameField[i+1] = i/2+1;
	}
	
	shuffle(gameField);
}

//Funkce volana po nacteni stranky
function onPageLoad()
{
	initGameField();
	setPlayer(activePlayer);
}

/**************************************
» Jonas Raoni Soares Silva
» http://www.joninhas.ath.cx
**************************************/
function shuffle(o){ //v1.0
	for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
	return o;
}